module Hittable (Shape (..), Circle (..), Hit (..)) where

import Linear.V3
import Linear.Vector
import Maths
import Ray

class Shape s where
  testHit :: Ray Double -> s -> Maybe Hit

data Circle = Circle (V3 Double) Double

data Hit = Hit {root :: Double, p :: V3 Double, n :: V3 Double}

instance Shape Circle where
  testHit (Ray o d) (Circle center r) =
    if discriminant < 0.0
      then Nothing
      else Just (Hit root p (p - center ^/ r))
    where
      co = o - center
      a = lengthSquared d -- a vector dotted with itself is = lengthSquared
      b = d `dotP` co
      c = lengthSquared co - r ^ 2
      discriminant = b ^ 2 - a * c
      root = (b * (-1.0) - sqrt discriminant) / a
      p = rayAt (Ray o d) root

-- would make sense to build a Functor for shapes
